import { Component } from './component';
import { Project } from './project';
import { Task } from './tasks';
/**
 * (experimental) Options for `Version`.
 *
 * @experimental
 */
export interface VersionOptions {
    /**
     * (experimental) A name of a .json file to set the `version` field in after a bump.
     *
     * @experimental
     * @example
     *
     * "package.json"
     */
    readonly versionFile: string;
    /**
     * (experimental) The name of the directory into which `changelog.md` and `version.txt` files are emitted.
     *
     * @experimental
     */
    readonly artifactsDirectory: string;
}
/**
 * @experimental
 */
export declare class Version extends Component {
    /**
     * @experimental
     */
    static readonly STANDARD_VERSION = "standard-version@^9";
    /**
     * @experimental
     */
    readonly bumpTask: Task;
    /**
     * @experimental
     */
    readonly unbumpTask: Task;
    /**
     * (experimental) The name of the changelog file created by the `bump` task.
     *
     * @experimental
     */
    readonly changelogFile: string;
    /**
     * (experimental) An uncommitted JSON file that will include a "version" field with the bumped version.
     *
     * Created by the `bump` task.
     *
     * @experimental
     */
    readonly bumpFile: string;
    /**
     * @experimental
     */
    constructor(project: Project, options: VersionOptions);
}
